#ifndef __delay
#define __delay

#include "multi_curve.h"
#include "solver.h"
#include "listeners.h"

struct delay { // 1 channel delay

  int nsamples;

  float* samples;
  float* fbk;
  float* vol;
  int id;

	float msecs; // delay time

	// feedback and volume are beziers solved into fbk and vol
	std::string fbk_fname, vol_fname;
	multi_curve fbk_crv, vol_crv;
	delay_listener fbk_lis, vol_lis;
	solver fbk_sol, vol_sol;

	delay (float t, float f, float v, const std::string& fn, const std::string& vn);
	~delay ();
	void zero ();
	void check_buffer ();
	void operator() (float* out, int nz);
	void set (float t);
	void get (float& t);

};
#endif
