#ifndef __globals
#define __globals

#include "tokenizer.h"
#include <string>
#include <cstring>

struct load_globals {
  std::string ignore;
	bool load_intervals (const std::string& fname);
	void load_note_colors (const std::string& fname);
	void load_last_window ();
	load_globals ();
};


void calc_volume_vars (int height);
void calc_tonic_limits ();

template <class T> struct pusher {
	virtual T& operator<< (const std::string& s)=0;
	virtual T& operator<< (char c)=0;
};

template<class T> void into_lines (const char* str, pusher<T>& push) {

	static tokenizer tz;
	static const std::string newline = "\n";
	static const char endln = '\n';

	if (strlen (str)) {
		tz.set (str, newline);
		std::string ln;
		while (1) {
			std::string ln; tz >> ln;
			if (ln == "") break; else { push << ln << endln; }
		}
	}
}

#endif
