#ifndef __MORSE_CODE
#define __MORSE_CODE

#include "command.h"
#include "multi_curve.h"
#include "curve_editor.h"
#include "listeners.h"

struct morse_code : command { // convert text to morse code to multi_curve to use as a pattern

	int ncodes;
	map <char, string> code;

	multi_curve dot, dash, inner;
	multi_curve letter, word;

	curve_editor ed;
	morse_code_listener lis;

	int add_first_vertex;
	point<float> org;
	point<float> vi;

	morse_code (const string& ln, const string& sn);
	~morse_code ();

	bool load (const string& fname);
	bool operator() (tokenizer& tz);
	bool create_pattern (const string& text);
	void append (multi_curve& m, multi_curve& p);

};

#endif
