#ifndef __oscilloscope
#define __oscilloscope

#include "box.h"
#include "ui.h"

struct oscilloscope : ui {

  static const int MAX_SAMPLES = 512;

  int num_samples;

	void add_samples (float* out, int n);

	struct sample_t {
		float left, right; // stereo pair
		static float lmin, lmax;
		static float rmin, rmax;
		sample_t () {
			left = right = 0;
		}
	} samples [MAX_SAMPLES];

	int paused;
	int visible;
	void toggle_pause ();
	void toggle_visible ();
	
	int viewr;
	int addr;

	oscilloscope ();
	~oscilloscope ();
	bool load_last ();
	bool save_last ();

  box<int> win;
  float* vertex_array;
  float* color_array;
	float lr, lg, lb;
	float rr, rg, rb;
	int leftx, rightx, base, ndraw;
	void calc_draw_params ();	

	void draw ();

	bool handle_input ();

};
#endif
