#ifndef __phrasor
#define __phrasor

#include <vector>
#include "box.h"
using namespace std;

#include "point.h"

struct phrasor {
  
  vector < point<int> > data;
	int sz, lst;
	
  int state;
  enum {stopped, recording, playing, paused};
  
  int cur;
  int cue;
  
  int recl;
    
  phrasor () {
    state = stopped;
    cur = 0;
    cue = 0;
		sz = 0;
		lst = -1;
  }
        
  void get (int& win_mousex, int& win_mousey) {
    point<int>& pt = data[cur];
    win_mousex = pt.x; 
    win_mousey = pt.y;
  }
  
  void next () {
    int c = cur + 1;
    if (c >= sz) cur = 0; else cur = c;
  }
  
  void clear () {
    state = stopped;
    data.clear ();
    cur = cue = 0;
		sz = 0; lst = -1;
  }
  
  void jog (int j) {
    int c = cur + j;
    if (c >= sz) cur = 0; else if (c < 0) cur = lst; else cur = c;
  }
  
  void play () {
    if (cur < sz) state = playing;
  }
  
  void set_cue () {
    cue = cur;
  }
  
  void goto_cue () {
    cur = cue; 
  }
	
	void validate () {
		sz = data.size ();
		lst = sz - 1;
	}
	
	void rec () {
		state = phrasor::recording;
		recl = cur = sz;
	}
	
	void draw (unsigned int i, float r, float g, float b);
      
};

#endif
