#ifndef __SCALE_INFO
#define __SCALE_INFO

#include <string>
#include <map>

struct scale_info {

	std::string name;

	float tonic, lo_tonic, hi_tonic;
	int num_octaves;

	std::map <std::string, float> intervals;

	static const int MAX_NOTES = 16;
	std::string notes [MAX_NOTES];
	int num_ranges;
	int last_range;


	scale_info () {
		num_octaves = 3;
		num_ranges = 0;
		last_range = -1;
		intervals.clear ();
	}

	void load_last ();
	void save_last ();

	int set_tonic (float s);
	bool set_scale (const std::string& n);

	bool load_custom_tuning ();
	void save_custom_tuning ();


};

#endif
