// string tokenizer
// based on code by Song Ho Ahn (song.ahn@gmail.com)

#ifndef TOKENIZER_H
#define TOKENIZER_H

#include <string>
#include <vector>

const std::string DEFAULT_DELIMITER = " ";

struct tokenizer {

	tokenizer();
	tokenizer(const std::string& s, const std::string& d=DEFAULT_DELIMITER);
	tokenizer (const std::vector<std::string>& tokens);

	tokenizer& operator>> (std::string& s);
	tokenizer& operator>> (float& f);
	tokenizer& operator>> (int& i);
	tokenizer& operator>> (char& c);

	std::vector<std::string> tokens;
	int tokens_available;
	unsigned int tokid;

	std::string delimiter;
	std::string buffer;
	int blen, dlen;
	void str (const std::string& s);
	void del (const std::string& d);
	void vec (const std::vector<std::string>& v);
	void set (const std::string& s, const std::string& d=DEFAULT_DELIMITER);
	bool isdelim (char c);
	void skip_ws ();

	int cur;
	void init_cur ();

	std::string cur2end ();

	std::string token;

};

#endif
