#include "scalelist.h"
#include "scale_info.h"
#include "console.h"
#include "tokenizer.h"
#include "utils.h"

#include <fstream>
#include <iostream>
using namespace std;

int scale_info::set_tonic (float s) {

	tonic = s;
	lo_tonic = tonic / 2.;
	hi_tonic = tonic * 2.;
	extern float MIN_TONIC, MAX_TONIC;
	if (s < MIN_TONIC || s > MAX_TONIC) return 0; else return 1;

}

bool scale_info::set_scale (const string& n) {

	extern scalelist scalelst;
	scale r; if (scalelst.get (n, r) == false) return false;

	name = r.name;
	num_ranges = r.num_notes - 1;
	last_range = num_ranges - 1;

	tokenizer tz (r.notes);
	for (int i = 0; i < r.num_notes; ++i) {
		tz >> notes[i];
	}

	if (load_custom_tuning() == false) {
		extern map<string, float> INTERVALS;
		intervals = INTERVALS;
	}

	return true;

}

bool scale_info::load_custom_tuning () {

	extern string dotdin;
	string filename = dotdin + name + ".intervals";

	ifstream file (filename.c_str(), ios::in);
	if (!file) {
		cout << "couldnt load custom tuning from: " << filename << "; will use defaults." << endl;
		return false;
	}

	string ignore;

	int n;
	file >> ignore >> n;

	for (int i = 0; i < n; ++i) {
		string c;
		float f;
		file >> c >> f;
		intervals [c] = f;
	}

	return true;


}

void scale_info::save_custom_tuning () {
	extern string dotdin;
	string filename = dotdin + name + ".intervals";
	ofstream file (filename.c_str(), ios::out);
	if (!file) return;

	file << "num_intervals " << intervals.size () << endl;
	for (map<string, float>::iterator i = intervals.begin(), j = intervals.end(); i != j; ++i) {
		pair<string, float> p = *i;
		file << p.first << ' ' << p.second << endl;
	}

}
